=== debian/changelog ===
hueplusplus (1.2.0+ds-2) unstable; urgency=medium

  * Add d/gbp.conf for a better gbp-clone
  * Fix FTBFS on openrgb due to nlohmann-json3 version
  * Add doc/html to clean to allow repeat build
  * d/control: Add and generate Static-Built-Using

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Sat, 31 May 2025 16:26:59 +0100

hueplusplus (1.2.0+ds-1) unstable; urgency=medium

  * New upstream version 1.2.0
  * d/copyright: remove excludes after upstream movement
  * d/patches: remove all patches after upstream fixes
  * d/rules: quieter build output
  * d/not-installed: fix path of ignore static lib
  * d/control: bump standards version to latest 4.7.2

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Tue, 15 Apr 2025 17:14:58 +0100

hueplusplus (1.1.0+ds-2) unstable; urgency=medium

  * Source-only upload for testing migration

 -- Matthias Geiger <werdahias@debian.org>  Tue, 15 Apr 2025 10:47:33 +0200

hueplusplus (1.1.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1091681)
  * d/copyright: Add missing copyright holders
  * d/copyright: split additional copyright holders

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Mon, 24 Feb 2025 18:16:36 +0000
