=== debian/control ===
Source: hueplusplus
Section: libs
Priority: optional
Maintainer: Ahmad Khalifa <ahmad@khalifa.ws>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               libmbedtls-dev,
               nlohmann-json3-dev
Build-Depends-Indep: dh-sequence-doxygen, doxygen, graphviz
Standards-Version: 4.7.2
Homepage: https://github.com/enwi/hueplusplus
Vcs-Browser: https://salsa.debian.org/debian/hueplusplus
Vcs-Git: https://salsa.debian.org/debian/hueplusplus.git

Package: libhueplusplus1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Static-Built-Using: ${StaticBuiltUsing}
Description: simple C++ library to control Philips Hue lights
 A simple and easy to use library for Philips Hue Lights
 Features:
  - find bridges with SSDP or set an ip manually
  - all common light functions (brightness, color, temperature)
  - extended alert() functions, which alert in a specific color
    (good for notifications)
  - supports sensors, rules, groups, scenes and schedules
  - streaming with entertainment mode
  - documented with doxygen
  - tested with google test, google mock and gcov/lcov

Package: libhueplusplus1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libhueplusplus1 (= ${binary:Version}), ${misc:Depends}
Description: simple C++ library to control Philips Hue lights (headers)
 A simple and easy to use library for Philips Hue Lights.
 .
 This package provides the header files.

Package: libhueplusplus1-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: simple C++ library to control Philips Hue lights (docs)
 A simple and easy to use library for Philips Hue Lights.
 .
 This package provides the documentation files.
