=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
# compile nlohmann-json3 without versioned namespaces: #1106432
export DEB_CXXFLAGS_MAINT_APPEND = -DNLOHMANN_JSON_NAMESPACE_NO_VERSION
NL3_VERSION = $(shell dpkg-query '--showformat=$${Version}' --show 'nlohmann-json3-dev')

%:
	dh $@

execute_after_dh_auto_build-indep:
	# build docs and replace version
	sed 's/^PROJECT_NUMBER.*/PROJECT_NUMBER = $(DEB_VERSION)/' Doxyfile | \
		doxygen -

override_dh_gencontrol:
	test ! -z "$(NL3_VERSION)"
	dh_gencontrol -- -VStaticBuiltUsing="nlohmann-json3-dev (= $(NL3_VERSION))"
