=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, \
    repacksuffix=+ds, dversionmangle=s/\+ds//" \
    https://github.com/enwi/hueplusplus/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

# previously used to pull in commits from branch external-deps
#opts="mode=git, pgpmode=none, pretty=1.1.0+git%cd" \
#  https://github.com/enwi/hueplusplus.git heads/external-deps
